//
// Generates low-frequency clocks
//
module frame_counter (
	input              clk,
	output reg         fc_qfr_clk,    // approx. 240 Hz
	output reg         fc_hfr_clk,    // approx. 120 Hz
    output reg         fc_frame_intr, // approx. 60 Hz
    output wire [13:0] test
);

    reg [13:0] seq;
    reg [ 9:0] divider;
    assign test = seq;

    always @ ( posedge clk ) begin
        
        // Step through Mode 0 4-step sequence
        seq <= seq + 14'd1;

        if ( seq == 14'd1864 ) begin
            fc_qfr_clk <= 1'b0;
        end
        else if ( seq == 14'd3728 ) begin
            fc_qfr_clk <= 1'b1;
            fc_hfr_clk <= 1'b0;
        end
        else if ( seq == 14'd5592 ) begin
            fc_qfr_clk <= 1'b0;
        end
        else if ( seq == 14'd7456 ) begin
            fc_qfr_clk    <= 1'b1;
            fc_hfr_clk    <= 1'b1;
            fc_frame_intr <= 1'b0;
        end
        else if ( seq == 14'd9320 ) begin
            fc_qfr_clk <= 1'b0;
        end
        else if ( seq == 14'd11185 ) begin
            fc_qfr_clk <= 1'b1;
            fc_hfr_clk <= 1'b0;
        end
        else if ( seq == 14'd13049 ) begin
            fc_qfr_clk <= 1'b0;
        end
        else if ( seq == 14'd14914 ) begin
            fc_qfr_clk    <= 1'b1;
            fc_hfr_clk    <= 1'b1;
            fc_frame_intr <= 1'b1;
            seq           <= 14'd0;
        end
        
    end // end always block

endmodule